require 'sketchup.rb'

require 'extensions.rb'

require 'net/http'

require 'uri'

require 'json'

require 'socket'

require 'win32ole'

require 'open-uri'

require 'find'



module A4Design_EnscapeMaterialConverter

	@global_license_enscape  = true

	########### KI?M TRA K?T N?I INTERNET ##################

	def self.internet_connected?

		url = URI.parse('http://www.163.com')

		response = Net::HTTP.get_response(url)

		response.is_a?(Net::HTTPSuccess)

		rescue

		false

	end

	########################################################

	

	# ########### KI?M TRA PHIêN B?N M?I #####################

	# def self.checkversion()

		# current_version = '25.25.05.2023'

		# version_url = 'https://dl.dropboxusercontent.com/s/rk418ace33o5yo2/EnscapeMaterialConverterVersion.txt'

		# if internet_connected?

			# open(version_url) do |f|

				# latest_version = f.read.strip.split('=').last

				# if current_version < latest_version

					# message = "An update is available! The latest version is #{latest_version}. Do you want to update now?"

					# answer = UI.messagebox(message, MB_YESNO)

					# if answer == IDYES

						# update_url = 'https://extensions.sketchup.com/extension/eb32a200-736a-4669-b22a-f51908eafab1/enscape-material-converter-pro-version'

						# UI.openURL(update_url)

						# #puts "Update started."

						# else

						# #puts "Update canceled."

					# end

					# else

					# UI.messagebox("You have the latest version (#{current_version}).")

					# Sketchup.set_status_text("You have the latest version (#{current_version}).")

				# end

			# end

			# else

			# #puts "Not connected to the Internet"

		# end

	# end

	# ########################################################

	

	########### GOOGLE ANALYTICS ###########################

	def self.run_google_analytics

		hostname = Socket.gethostname

		dialog = UI::WebDialog.new("Enscape 材质转换器", true, "Enscape 材质转换器", 0, 0, 0, 0, false)

		dialog.set_size(0, 0)

		dialog.set_url("https://enscapematerialconverter.blogspot.com?id=" + hostname)

		dialog.show

	end

	########################################################

	

	########### T?O FOLDER CH?A MAP PBR ####################

	def self.copy_folder(source, destination)

		unless File.exist?(destination)

			# T?o các th? m?c con n?u ch?a t?n t?i

			directories = destination.split("/")

			directories.each_with_index do |directory, index|

				dir_path = directories[0..index].join("/")

				unless Dir.exist?(dir_path)

					Dir.mkdir(dir_path)

				end

			end

		end

		total_size = 0

		Find.find(destination) do |f|

			total_size += File.size(f) if File.file?(f)

		end

		if total_size < 48836903

			# Sao chép các file và th? m?c t? th? m?c ngu?n sang th? m?c ?ích

			Dir.foreach(source) do |file_name|

				next if file_name == '.' || file_name == '..'

				source_file = File.join(source, file_name)

				destination_file = File.join(destination, file_name)

				if File.directory?(source_file)

					copy_folder(source_file, destination_file)

					else

					File.open(destination_file, "wb") do |dest_file|

						File.open(source_file, "rb") do |src_file|

							dest_file.write(src_file.read)

						end

					end

				end

			end

		end

	end

	########################################################

	

	# ####### L?Y S? SERIAL ? C?NG CH?A SKETCHUP #############

	# def self.get_hard_drive_serial_number

		# plugins_dir = Sketchup.find_support_file('Plugins')

		# drive = plugins_dir.slice(0)

		# wmi = WIN32OLE.connect("winmgmts:\\\\.")

		# drive = wmi.ExecQuery("select * from Win32_LogicalDisk where DeviceID = '" + drive + ":'")

		# serial = ""

		# drive.each do |d|

			# serial = d.VolumeSerialNumber

		# end

		# return serial

	# end

	# ########################################################

	

	# ######### KI?M TRA SERIAL ?? CàI ? MáY KHáC HAY CH?A ###

	# def self.check_serial_installed(serial,valuecheck)

		# url = URI.parse("https://a4design.org/Check.php?id=" + serial)

		# http = Net::HTTP.new(url.host, url.port)

		# http.use_ssl = true if url.scheme == 'https'

		# response = http.get(url.request_uri)

		# # L?y d? li?u ph?n h?i t? ph?n h?i HTTP

		# value = response.body

		# # Ki?m tra xem valuecheck có n?m trong ph?n h?i hay kh?ng

		# if value.include?(valuecheck)

			# return true

			# else

			# return false

		# end

	# end

	# ########################################################

	

	# ######### KI?M TRA LICENSE #############################

	# def self.check_license

		# if internet_connected?

			# #puts "Connected to the Internet"

			# @global_license_enscape = false

			# # L?y serial ? c?ng ch?a Sketchup

			# disk_serial_number = get_hard_drive_serial_number

			# #UI.messagebox(disk_serial_number)

			# # Tìm ???ng d?n th? m?c plugin c?a SketchUp

			# plugin_folder = File.join(Sketchup.find_support_file('Plugins/A4design_Enscape/License'), 'License.dat')

			# if !File.exist?(plugin_folder) || File.zero?(plugin_folder)

				# # Hi?n th? dialog nh?p serial

				# prompt = 'Enter serial:'

				# serial = UI.inputbox([prompt], [''],'Enscape Material Converter')[0]

				# newserial = serial + "&fi=" + disk_serial_number

				# # Ki?m tra serial

				# if check_serial_installed(newserial,"Valid") or check_serial_installed(newserial,"Installed")

					# # Ghi serial vào file license.dat

					# File.write(plugin_folder, serial)

					# #UI.messagebox('Serial h?p l?! ?? l?u vào file license.dat')

					# @global_license_enscape = true

					# elsif check_serial_installed(newserial,"Invalid")

					# UI.messagebox('Invalid Serial !')

					# @global_license_enscape = false

					# elsif check_serial_installed(newserial,"Used")

					# UI.messagebox('This serial number has already been installed on another machine !')

					# @global_license_enscape = false

					# else

					# UI.messagebox('Can not check serial !')

					# @global_license_enscape = false

				# end

				# else

				# # ??c serial t? file license.dat

				# serial = File.read(plugin_folder).strip

				# newserial = serial + "&fi=" + disk_serial_number

				# # Ki?m tra serial

				# if check_serial_installed(newserial,"Installed")

					# #UI.messagebox('Serial trên máy này kh?p v?i serial trên server')

					# @global_license_enscape = true

					# elsif check_serial_installed(newserial,"Invalid")

					# # Hi?n th? dialog nh?p serial

					# prompt = 'Enter serial:'

					# serial = UI.inputbox([prompt], [''],'Enscape Material Converter')[0]

					# newserial = serial + "&fi=" + disk_serial_number

					# # Ki?m tra serial

					# if check_serial_installed(newserial,"Valid") or check_serial_installed(newserial,"Installed")

						# # Ghi serial vào file license.dat

						# File.write(plugin_folder, serial)

						# #UI.messagebox('Serial h?p l?! ?? l?u vào file license.dat')

						# @global_license_enscape = true

						# elsif check_serial_installed(newserial,"Used")

						# UI.messagebox('This serial number has already been installed on another machine !')

						# @global_license_enscape = false

						# elsif check_serial_installed(newserial,"Invalid")

						# UI.messagebox('Invalid Serial !')

						# @global_license_enscape = false

						# else

						# UI.messagebox('Can not check serial !')

						# @global_license_enscape = false

					# end

					# else

					# UI.messagebox('This serial number has already been installed on another machine !')

					# @global_license_enscape = false

				# end      

			# end

			# # N?u kh?ng nh?p serial ho?c cancel thì @global_license_enscape = false

			# if serial.nil? || serial.empty?

				# # Th?ng báo k?t qu?

				# #UI.messagebox('Invalid Serial !')

				# @global_license_enscape = false

			# end

			# else

			# UI.messagebox("Please connect to the internet to use the plugin !")

		# end

	# end		

	# ########################################################

	

	######### KI?M TRA LICENSE KHI KH?I ??NG ###############

	def self.check_license_start

		if internet_connected?

			@global_license_enscape = true

			# disk_serial_number = get_hard_drive_serial_number

			# plugin_folder = File.join(Sketchup.find_support_file('Plugins/A4design_Enscape/License'), 'License.dat')

			if !File.exist?(plugin_folder) || File.zero?(plugin_folder)

				@global_license_enscape = true

				# else

				# serial = File.read(plugin_folder).strip

				# newserial = serial + "&fi=" + disk_serial_number

				if check_serial_installed(newserial,"Installed")

					@global_license_enscape = true

					else

					@global_license_enscape = true

				end

			end

			else

			#UI.messagebox("Please connect to the internet to use the plugin !")

		end

	end

	########################################################

	

	######### SAVE 1 V?T LI?U ##############################

	def self.save_material_to_file

		if @global_license_enscape

			model = Sketchup.active_model

			materials = model.materials

			selected_mat = model.materials.current

			if selected_mat.nil?

				UI.messagebox("没有选择材质。")

				else

				material_name = selected_mat.name

				skm_name = material_name + '.skm'

				file_location = UI.savepanel("保存材质", nil, skm_name, "材质文件|*.skm|All Files|*.*||")

				if file_location.nil?

					#UI.messagebox("Material save cancelled.")

					else

					# Save .skm file to folder

					selected_mat.save_as(file_location)

				end

			end

			else

			check_license()

		end

	end

	########################################################

	

	######### SAVE ALL V?T LI?U ############################

	def self.save_all_material_to_file

		if @global_license_enscape

			model = Sketchup.active_model

			materials = model.materials

			# Hi?n th? th?ng báo xác nh?n tr??c khi ch?n v? trí l?u tr?

			confirm = UI.messagebox('将所有材质保存到硬盘的操作可能需要一段时间，并有可能导致系统卡顿。您想继续吗？', MB_YESNO)

			if confirm == IDYES

				# Ch?n th? m?c l?u tr?

				save_folder = UI.select_directory(title: '选择文件夹保存所有材质')

				if save_folder

					# Ki?m tra xem có ít nh?t m?t v?t li?u trong danh sách hay kh?ng

					if materials.size > 0

						# L?u các v?t li?u thành file .skm

						materials.each do |material|

							# T?o m?t tên file d?a trên tên c?a v?t li?u

							filename = "#{material.name}.skm"

							# T?o ???ng d?n cho file

							material_location = File.join(save_folder, filename)

							# L?u file .skm

							material.save_as(material_location)

						end

						UI.messagebox("所有材质已成功保存 !")

						else

						UI.messagebox("文件中没有材质 !")

					end

					else

					UI.messagebox('未选择存储文件夹 !')

				end

			end

			else

			check_license()

		end

	end

	########################################################

	

	######### XOá RáC LàM S?CH FILE ########################

	def self.purger

		if @global_license_enscape

			model = Sketchup.active_model

			model.start_operation("清除未使用的内容", true)

			

			cd = model.definitions.count

			model.definitions.purge_unused

			cd = cd - model.definitions.count

			

			cl = model.layers.count

			model.layers.purge_unused

			cl = cl - model.layers.count

			

			cm = model.materials.count

			model.materials.purge_unused

			cm = cm - model.materials.count

			

			cs = model.styles.count

			model.styles.purge_unused

			cs = cs - model.styles.count

			

			UI.messagebox("清理完成 汉化：SUCJ.ME\n\n材质 :\t\t\t "+cm.to_s+" 已删除 \n组件 :\t\t\t "+cd.to_s+" 已删除 \n图层|标记 :\t\t\t "+cl.to_s+" 已删除 \n样式 :\t\t\t "+cs.to_s+" 已删除")

			model.commit_operation

			else

			check_license()

		end

	end		

	########################################################

	

	######### LINK MUA PLUGIN ##############################

	def self.buyme

		UI.openURL("https://a4design.gumroad.com/l/EnscapeMaterialConverter")

	end

	########################################################

	

	######### ?N HI?N CáC C?NH #############################

	def self.hide_unhide_all_edges(state)

		if @global_license_enscape

			model = Sketchup.active_model

			selection = model.selection

			selection = model.active_entities if selection.empty?

			model.start_operation ((state) ? "隐藏所有边线" : "取消隐藏所有边线")

			process_at_level state, selection, {}

			model.commit_operation

			else

			check_license()

		end

	end

	def self.process_at_level(state, entities, hcomp)

		entities.each do |entity| 

			case entity.typename

				when 'Group'

				process_at_level state, entity.entities, hcomp

				when 'ComponentInstance'

				edef = entity.definition

				next if hcomp[edef.to_s]

				hcomp[edef.to_s] = edef

				process_at_level state, edef.entities, hcomp

				when 'Edge'

				entity.hidden = state 

			end

		end

	end	

	########################################################

	

	######### THI?T L?P KHUNG 1:1 ##########################

	def self.set_frame_11

		count = Sketchup.active_model.selection.count

		view = Sketchup.active_model.active_view

		camera = view.camera

		

		if count == 0

			selected_entities = Sketchup.active_model.entities.to_a

			else

			selected_entities = Sketchup.active_model.selection.to_a

		end

		view.zoom(selected_entities)

		view.camera = camera

		view.refresh

		

		if count == 1

			selected_entity = selected_entities[0]

			bb = selected_entity.bounds

			else

			bb = Geom::BoundingBox.new

			selected_entities.each { |entity| bb.add(entity.bounds) }

		end

		

		center = bb.center

		distance = camera.eye.distance(center)

		if bb.width > bb.height

			puts "边界框长度大于高度"

			distance *= 1.8

			elsif bb.width < bb.height

			puts "边界框的高度大于长度"

			else

			puts "边界框的长度等于高度"

		end

		camera.set([center.x, center.y - distance, center.z], center, [0, 0, 1])

		selected_entity = nil

		view.camera = camera

		view.refresh

	end

	########################################################

	

	################# CODE MATERIAL REPLACE ################

	def self.activate_tool(suffix)

		@global_suffix = suffix

		my_tool = MaterialReplacer.new(@global_license_enscape,@global_suffix)

		Sketchup.active_model.tools.push_tool(my_tool)

	end

	

	class MaterialReplacer

		def initialize(license_enscape,suffix)

		    @global_license_enscape = license_enscape

			@global_suffix = suffix		

			@picked = nil

			@m_org = nil

			@state = 0		

			cursor_path = Sketchup.find_support_file('Plugins') + '/A4design_Enscape/icon/Pick.png'

			@c_dropper = UI.create_cursor(cursor_path, 0, 0)

			cursor_path2 = Sketchup.find_support_file('Plugins') + '/A4design_Enscape/icon/Pick.png'

			@c_dropper_err = UI.create_cursor(cursor_path2, 0, 0)

		end

		

		def activate

			@picked = nil

			@m_org = nil

			@state = 0

			@pos = [0,0,0]

			@drawn = false

			update_ui()		

			@debug = nil

		end

		

		def update_ui

			Sketchup.set_status_text('选择要更换的材质.')

		end

		

		def resume(view)

			update_ui()

		end

		

		def deactivate(view)

			view.invalidate if @drawn

		end

		

		def onMouseMove(flags, x, y, view)

			ph = view.pick_helper

			ph.do_pick(x + 4 , y + 30) #Hình tròn thì +16 +16 , picker thi +0 +28

			picked = (ph.picked_face.nil?) ? (ph.picked_edge.nil?) ? ph.best_picked : ph.picked_edge : ph.picked_face

			index = 0

			for i in 1..ph.count

				if ph.element_at(i) == picked

					index = i

					break

				end

			end

			path = ph.path_at(index)

			t = ph.transformation_at(index)

			

			if path.nil?

				@picked = nil

				else

				@picked = nil

				n = ( picked.is_a?(Sketchup::Face) ) ? picked.normal.transform(t).normalize : nil

				path.each { |e|

					next unless e.respond_to?(:material)

					if e.is_a?(Sketchup::Face)

						c = Sketchup.active_model.active_view.camera.direction

						m = (c % n > 0) ? e.back_material : e.material

						next if m.nil?

						@picked = m

						else

						next if e.material.nil?

						@picked = e.material

					end

				}

			end

			

			@pos = [x,y,0]

			view.invalidate

		end

		

		def onLButtonUp(flags, x, y, view) 

			if @global_license_enscape	  	  

				model = Sketchup.active_model

				entities = model.active_entities

				materials = model.materials

				materials.current = @picked

				current_material = materials.current

				default_material = model.materials["Default"]

				suffix = @global_suffix				

				if suffix == "_A4Design_Replace"

					if @state == 0

						@m_org = @picked

						@state = 1

						o_name = (@m_org.nil?) ? 'Default' : @m_org.display_name

						Sketchup.set_status_text("选择另一种材质进行更改 #{o_name}.")

						else

						return if @picked == @m_org

						model = Sketchup.active_model

						model.start_operation('Change materials', true)

						Sketchup.set_status_text('更换材质。请稍候...')

						

						model.entities.each { |e|

							if e.respond_to?(:material)

								e.material = @picked if e.material == @m_org

							end

							if e.respond_to?(:back_material)

								e.back_material = @picked if e.back_material == @m_org

							end

						}

						model.definitions.each { |d|

							next if d.image?

							d.entities.each { |e|

								if e.respond_to?(:material)

									e.material = @picked if e.material == @m_org

								end

								if e.respond_to?(:back_material)

									e.back_material = @picked if e.back_material == @m_org

								end

							}

						}

						

						model.commit_operation

						activate

					end

					else

					if current_material == default_material

						UI.messagebox("无法重命名默认材料")      

						else

						model.start_operation('make enscape material', true)

						index = current_material.name.index("_A4Design")

						new_name = if index

							current_material.name.slice(0, index) + suffix

							else

							current_material.name + rand(101).to_s + suffix

						end

						current_material.name = new_name

						current_material.alpha = 1

						case current_material.name      

							when /A4Design_Gold/

							change_material_color(212, 175, 55)

							when /A4Design_Silver/

							change_material_color(192, 192, 192)

							when /A4Design_Bronze/

							change_material_color(150, 116, 68)

							

							when /A4Design_Mesh/

							texture_path = File.join(Sketchup.find_support_file('Plugins'), 'A4design_Enscape/Image/Mesh.png')

							image_height = 24

							image_width = 24

							texture = [texture_path, image_width, image_height]

							current_material.texture = texture

							

							when /A4Design_Gravel|A4Design_Wood_Floor3|A4Design_Plaster|A4Design_White_Paint|A4Design_Velvet|A4Design_Leather|A4Design_Roof/

							old_name = new_name

							case new_name

								when /A4Design_Gravel/

								file_name = "Gravel"

								when /A4Design_Wood_Floor3/

								file_name = "Wood_Floor3"

								when /A4Design_Plaster/

								file_name = "Plaster"

								when /A4Design_White_Paint/

								file_name = "White_Paint"

								when /A4Design_Velvet/

								file_name = "Velvet"

								when /A4Design_Leather/

								file_name = "Leather"

								when /A4Design_Roof/

								file_name = "Roof"

							end

							material_path = File.join(Sketchup.find_support_file('Plugins'), "A4design_Enscape/Materials/#{file_name}.skm")

							new_material = Sketchup.active_model.materials.load(material_path)

							apvatlieu(new_material.name)        

							Sketchup.active_model.materials.current = model.materials[new_material.name]

							Sketchup.active_model.materials.current.name = new_material.name + rand(101).to_s

							Sketchup.active_model.materials.remove(Sketchup.active_model.materials[old_name])

							

							when /A4Design_Manual/

							old_name = new_name

							material_path = UI.openpanel("选择要加载的材料文件", "C:/A4DESIGN/Image/Assets/Material/Enscape", "*.skm")

							if material_path

								new_material = Sketchup.active_model.materials.load(material_path)

								apvatlieu(new_material.name)        

								Sketchup.active_model.materials.current = model.materials[new_material.name]

								Sketchup.active_model.materials.current.name = new_material.name + rand(101).to_s

								Sketchup.active_model.materials.remove(Sketchup.active_model.materials[old_name])     

							end

							

							when /A4Design_Reset/

							old_name = new_name

							white_material = materials.add('A4Design_White_Default' + rand(101).to_s)

							white_material.color = Sketchup::Color.new(255, 255, 255)

							apvatlieu(white_material.name)

							Sketchup.active_model.materials.current = Sketchup.active_model.materials[white_material.name]

							Sketchup.active_model.materials.remove(Sketchup.active_model.materials[old_name])  

							

							when /A4Design_Glass|A4Design_Water|A4Design_Ocean|A4Design_River/

							current_material.alpha = 0.1

							

							when /A4Design_Frosted Glass/

							current_material.alpha = 0.8

						end    

						model.commit_operation

						activate    

					end

				end			

				else

				A4Design_EnscapeMaterialConverter.check_license()

			end	  			

		end

		

		def draw(view)

			pos = @pos

			pos[0] += 35

			pos[1] -= 0

			if @state == 0

				p_name = (@picked.nil?) ? 'Default' : @picked.display_name

				str = "修改 #{p_name} ..."

				view.draw_text(pos, str)

				else

				o_name = (@m_org.nil?) ? 'Default' : @m_org.display_name

				p_name = (@picked.nil?) ? 'Default' : @picked.display_name

				str = "以 #{p_name}\n替换 #{o_name}"

				view.draw_text(pos, str)

			end

			

			@drawn = true

		end

		

		def onSetCursor

			if @state == 1 && @picked == @m_org

				UI.set_cursor(@c_dropper_err)

				else

				UI.set_cursor(@c_dropper)

			end

		end

		

		def apvatlieu(vatlieumoi)

			dialog = UI::HtmlDialog.new({:resizable => false})

			width = 127

			height = 150

			dialog.set_size(width, height)

			dialog.center

			#dialog.set_html('<h2 class="animate">Applying material</h2>')

			dialog.set_file(Sketchup.find_support_file('Plugins/A4design_Enscape/Image/Loading.gif', 'Plugins/A4design_Enscape/Image/Loading.gif'))

			UI.start_timer(0.5, false) {

				dialog.close

			}

			dialog.show

			

			model = Sketchup.active_model

			current_material = model.materials.current

			Sketchup.set_status_text('替换材料。请稍候...')

			# Thay doi vat lieu cho cac thanh phan trong entities va definitions

			[model.entities, *model.definitions.map(&:entities)].each do |entities|

				entities.each do |e|

					if e.respond_to?(:material)

						e.material = vatlieumoi if e.material == current_material

					end

					if e.respond_to?(:back_material)

						e.back_material = vatlieumoi if e.back_material == current_material

					end

				end

			end

			#dialog.close

		end

		

		def change_material_color(red, green, blue)

			model = Sketchup.active_model

			materials = model.materials

			current_material = materials.current

			if current_material

				current_material.color = Sketchup::Color.new(red, green, blue)

				else

				UI.messagebox("未选择材质")

			end

		end

	end

	########################################################

	

	################# PH??NG TH?C CHíNH KH?I ??NG ##########

	def self.main_start

		run_google_analytics()

		copy_folder(Sketchup.find_support_file('Plugins') + '/A4design_Enscape/Image', 'C:/A4DESIGN/Image')

		check_license_start()

	end

	########################################################

	

	main_start()

	

	################# T?O MENU SKETCHUP ####################

	commands = [

		["水", "_A4Design_Water", "Water"],

		["海水", "_A4Design_Ocean", "Ocean"],

		["河水", "_A4Design_River", "River"],

		["草坪", "_A4Design_Grass", "Grass"],

		["高草", "_A4Design_Tall Grass", "Tall Grass"],

		["矮草", "_A4Design_Short Grass", "Short Grass"],

		["野草", "_A4Design_Wild Grass", "Wild Grass"],

		["叶子", "_A4Design_Leaf", "Leaf"],

		["长毛地毯", "_A4Design_Long Carpet", "Long Carpet"],

		["短毛地毯", "_A4Design_Short Carpet", "Short Carpet"],

		["自发光", "_A4Design_Emissive", "Emissive"],

		["磨砂玻璃", "_A4Design_Frosted Glass", "Frosted Glass"],

		["玻璃", "_A4Design_Glass", "Glass"],

		["镜子", "_A4Design_Mirror", "Mirror"],

		["塑料", "_A4Design_Plastic", "Plastic"],

		["瓷砖", "_A4Design_Ceramic", "Ceramic"],

		["大理石", "_A4Design_Marble", "Marble"],

		["金属", "_A4Design_Metal", "Metal"],

		["汽车漆", "_A4Design_Carpaint", "Carpaint"],

		["抛光面", "_A4Design_Polished", "Polished"],

		["釉面", "_A4Design_Glazing", "Glazing"],

		["亚克力", "_A4Design_Acrylic", "Acrylic"],

		["织物", "_A4Design_Fabric", "Fabric"],

		["镀铬", "_A4Design_Chrome", "Chrome"],

		["黄金", "_A4Design_Gold_Metal", "Gold"],

		["青铜", "_A4Design_Bronze_Metal", "Bronze"],

		["白银", "_A4Design_Silver_Metal", "Silver"],

		["网格", "_A4Design_Mesh_Metal", "Mesh"],

		["砾石", "_A4Design_Gravel_Ceramic", "Gravel"],

		["木地板", "_A4Design_Wood_Floor3", "Wood Floor"],

		["抹灰层", "_A4Design_Plaster", "Plaster"],

		["白色涂料", "_A4Design_White_Paint", "White Paint"],

		["丝绒", "_A4Design_Velvet", "Velvet"],

		["皮革", "_A4Design_Leather", "Leather"],

		["屋顶", "_A4Design_Roof", "Roof"],

		["自定义", "_A4Design_Manual", "Manual"],

		["重置", "_A4Design_Reset", "Reset"],

		["材质替换", "_A4Design_Replace", "Replace"]

	]

	

	toolbar = UI::Toolbar.new("A4Design - Enscape 材料工具栏")

	

	commands.each do |name, suffix, icon|

		cmd = UI::Command.new(name) { self.activate_tool(suffix) }

		cmd.small_icon = "icon/#{icon}.png"

		cmd.large_icon = "icon/#{icon}.png"

		cmd.tooltip = "材质: #{name}"

		toolbar.add_item(cmd)

	end

	

	save_cmd = UI::Command.new("保存材质") { save_material_to_file }

	save_cmd.small_icon = "icon/Save.png"

	save_cmd.large_icon = "icon/Save.png"

	save_cmd.tooltip = "保存材质"

	toolbar.add_item(save_cmd)

	

	saveall_cmd = UI::Command.new("保存全部材质") { save_all_material_to_file }

	saveall_cmd.small_icon = "icon/SaveAll.png"

	saveall_cmd.large_icon = "icon/SaveAll.png"

	saveall_cmd.tooltip = "保存全部材质"

	toolbar.add_item(saveall_cmd)

	

	Frame11_cmd = UI::Command.new("设置视口 1:1") {set_frame_11}

	Frame11_cmd.small_icon = "icon/Frame11.png"

	Frame11_cmd.large_icon = "icon/Frame11.png"

	Frame11_cmd.tooltip = "设置视口 1:1"

	toolbar.add_item(Frame11_cmd)

	

	HideEdge_cmd = UI::Command.new("隐藏所有边线") {hide_unhide_all_edges true}

	HideEdge_cmd.small_icon = "icon/HideEdge.png"

	HideEdge_cmd.large_icon = "icon/HideEdge.png"

	HideEdge_cmd.tooltip = "隐藏所有边线"

	toolbar.add_item(HideEdge_cmd)

	

	UnhideEdge_cmd = UI::Command.new("取消隐藏所有边线") {hide_unhide_all_edges false}

	UnhideEdge_cmd.small_icon = "icon/UnhideEdge.png"

	UnhideEdge_cmd.large_icon = "icon/UnhideEdge.png"

	UnhideEdge_cmd.tooltip = "取消隐藏所有边线"

	toolbar.add_item(UnhideEdge_cmd)

	

	Purge_cmd = UI::Command.new("清除未使用的内容") {purger}

	Purge_cmd.small_icon = "icon/Purge.png"

	Purge_cmd.large_icon = "icon/Purge.png"

	Purge_cmd.tooltip = "清除未使用的内容"

	toolbar.add_item(Purge_cmd)

	

	# Buy_cmd = UI::Command.new("Buy License") {buyme}

	# Buy_cmd.small_icon = "icon/Buy.png"

	# Buy_cmd.large_icon = "icon/Buy.png"

	# Buy_cmd.tooltip = "Buy License"

	# toolbar.add_item(Buy_cmd)

	

	# Update_cmd = UI::Command.new("Check Update") {checkversion}

	# Update_cmd.small_icon = "icon/Update.png"

	# Update_cmd.large_icon = "icon/Update.png"

	# Update_cmd.tooltip = "Check Update"

	# toolbar.add_item(Update_cmd)

	

	toolbar.show

end		
